/*
 * Created on Jun 8, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.websphere.sbf;

import java.util.HashMap;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.sdo.EType;

import com.ibm.websphere.ejbquery.QueryException;
import com.ibm.websphere.sbf.exceptions.MediatorMetaDataNotFoundException;
import com.ibm.websphere.sdo.mediator.ejb.Mediator;
import commonj.sdo.DataObject;

/**
 * @author DABERG
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class MediatorMetaDataCache extends HashMap {
	private EClassifier getRootType(DataObject dataObject) {
		DataObject root = getRoot(dataObject);
		return ((EType) root.getType()).getEClassifier();
	}
	private MediatorMetaData getMediatorMetaData(EClassifier type) throws MediatorMetaDataNotFoundException {
		MediatorMetaData md = (MediatorMetaData) get(type);
		if (md == null) {
			md = createMediatorMetaData(type);
			if (md == null)
				throw new MediatorMetaDataNotFoundException("Mediator meta-data not found for type " + type.getName());
			put(type, md);
		}
		return md;	
	}
	/**
	 * @param type
	 * @return
	 */
	protected abstract MediatorMetaData createMediatorMetaData(EClassifier type) ;

	/**
	 * Return the root of the containment tree of the given
	 * <code>dataObject</code>.
	 * @param dataObject
	 * @return
	 */
	private DataObject getRoot(DataObject dataObject) {
		assertValid(dataObject);
		DataObject root = dataObject;
		DataObject previous = null;
		while (root != null) {
			previous = root;
			root = root.getContainer();
		}
		return previous;
	}
	/**
	 * @param dataObject
	 */
	private void assertValid(DataObject dataObject) {
		if (dataObject == null)
			throw new IllegalArgumentException("Null DataObject value where non-null expected");
		if (dataObject.getDataGraph() == null)
			throw new IllegalStateException("The DataObject must be contained by a DataGraph.  Use the generated SdoClientFactory for object creation.");
	}
	public Mediator createMediator(DataObject dataObject) throws QueryException, MediatorMetaDataNotFoundException {
		return createMediator(getRootType(dataObject));
	}
	public Mediator createMediator(DataObject dataObject, Object[] whereClauseValues) throws QueryException, MediatorMetaDataNotFoundException {
		return createMediator(getRootType(dataObject), whereClauseValues);
	}
	public Mediator createMediator(DataObject dataObject, String[] queryStringOverrides, Object[] whereClauseValues) throws QueryException, MediatorMetaDataNotFoundException {
		return createMediator(getRootType(dataObject), queryStringOverrides, whereClauseValues);
	}
	public Mediator createMediator(EClassifier type) throws QueryException, MediatorMetaDataNotFoundException {
		MediatorMetaData md = getMediatorMetaData(type);
		return md.createMediator();
	}
	public Mediator createMediator(EClassifier type, Object[] whereClauseValues) throws QueryException, MediatorMetaDataNotFoundException {
		MediatorMetaData md = getMediatorMetaData(type);
		return md.createMediator(whereClauseValues);
	}
	public Mediator createMediator(EClassifier type, String[] queryStringOverrides, Object[] whereClauseValues) throws QueryException, MediatorMetaDataNotFoundException {
		MediatorMetaData md = getMediatorMetaData(type);
		return md.createMediator(queryStringOverrides, whereClauseValues);
	}
}
